## ros-foxy-pluginlib 2.5.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(pluginlib)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(NOT WIN32)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wpedantic")
endif()

find_package(ament_cmake REQUIRED)
find_package(ament_index_cpp REQUIRED)
find_package(class_loader REQUIRED)
find_package(rcutils REQUIRED)
find_package(rcpputils REQUIRED)
find_package(tinyxml2_vendor REQUIRED)
find_package(TinyXML2 REQUIRED)  # provided by tinyxml2 upstream, or tinyxml2_vendor

add_library(${PROJECT_NAME} INTERFACE)
target_include_directories(${PROJECT_NAME} INTERFACE
  "$<INSTALL_INTERFACE:include>")
ament_target_dependencies(${PROJECT_NAME} INTERFACE
  ament_index_cpp class_loader rcutils rcpputils TinyXML2)
ament_export_dependencies(ament_index_cpp class_loader rcutils rcpputils tinyxml2_vendor TinyXML2)
ament_export_include_directories(include)
ament_export_targets(${PROJECT_NAME})

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" AND CMAKE_CXX_FLAGS MATCHES "-stdlib=libc\\+\\+")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7.0)
    # Before LLVM 7.0, filesystem is part of experimental
    set(FILESYSTEM_LIB c++experimental)
  elseif(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.0)
    # Before LLVM 9.0 you have to manually link the fs library
    set(FILESYSTEM_LIB c++fs)
  else()
    # Starting at LLVM 9.0 filesystem is built in
    set(FILESYSTEM_LIB)
  endif()
elseif(CMAKE_CXX_COMPILER_ID MATCHES "QCC")
  if(CMAKE_CXX_FLAGS MATCHES "-stdlib=libstdc\\+\\+")
    set(FILESYSTEM_LIB stdc++fs)
  else()
    set(FILESYSTEM_LIB c++fs)
  endif()
else()
  set(FILESYSTEM_LIB stdc++fs)
endif()

if(UNIX AND NOT APPLE)
  # this is needed to use the experimental/filesystem on Linux, but cannot be passed with
  # ament_export_libraries() because it is not absolute and cannot be found with find_library
  target_link_libraries(${PROJECT_NAME}
    INTERFACE ${FILESYSTEM_LIB})
endif()

install(
  TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
)

install(
  DIRECTORY cmake
  DESTINATION share/${PROJECT_NAME}
)

install(
  DIRECTORY include/
  DESTINATION include
)

if(BUILD_TESTING)
  find_package(ament_cmake_gtest REQUIRED)

  # NOTE this block is also defined in pluginlib-extras.cmake
  # changes here need to be duplicated there
  if(CMAKE_CXX_COMPILER_ID MATCHES "Clang" AND CMAKE_CXX_FLAGS MATCHES "-stdlib=libc\\+\\+")
    if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7.0)
      # Before LLVM 7.0, filesystem is part of experimental
      set(FILESYSTEM_LIB c++experimental)
    elseif(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.0)
      # Before LLVM 9.0 you have to manually link the fs library
      set(FILESYSTEM_LIB c++fs)
    else()
      # Starting at LLVM 9.0 filesystem is built in
      set(FILESYSTEM_LIB)
    endif()
  else()
    set(FILESYSTEM_LIB stdc++fs)
  endif()

  include_directories(include test/include)

  add_library(test_plugins SHARED ./test/test_plugins.cpp)
  target_compile_definitions(test_plugins PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")
  target_compile_definitions(test_plugins PRIVATE "TEST_PLUGINLIB_FIXTURE_BUILDING_LIBRARY")
  ament_target_dependencies(
    test_plugins
    class_loader
  )

  include("cmake/pluginlib_enable_plugin_testing.cmake")
  pluginlib_enable_plugin_testing(
    CMAKE_TARGET_VAR mock_install_target
    AMENT_PREFIX_PATH_VAR mock_install_path
    PACKAGE_NAME "test_pluginlib"
    PACKAGE_XML "test/test_package.xml"
    PLUGIN_CATEGORY "test_pluginlib"
    PLUGIN_DESCRIPTIONS "test/test_plugins.xml"
    PLUGIN_LIBRARIES test_plugins
  )

  ament_add_gtest(${PROJECT_NAME}_unique_ptr_test
    test/unique_ptr_test.cpp
    APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:test_plugins>"
    APPEND_ENV AMENT_PREFIX_PATH=${mock_install_path}
  )
  if(TARGET ${PROJECT_NAME}_unique_ptr_test)
    ament_target_dependencies(
      ${PROJECT_NAME}_unique_ptr_test
      class_loader
      ament_index_cpp
      rcpputils
      rcutils
      TinyXML2
    )
    target_compile_definitions(${PROJECT_NAME}_unique_ptr_test PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")

    if(UNIX AND NOT APPLE)
      target_link_libraries(${PROJECT_NAME}_unique_ptr_test ${FILESYSTEM_LIB})
    endif()
    add_dependencies(${PROJECT_NAME}_unique_ptr_test "${mock_install_target}")
  endif()

  ament_add_gtest(${PROJECT_NAME}_utest
    test/utest.cpp
    APPEND_ENV AMENT_PREFIX_PATH=${mock_install_path}
  )
  if(TARGET ${PROJECT_NAME}_utest)
    ament_target_dependencies(
      ${PROJECT_NAME}_utest
      class_loader
      ament_index_cpp
      rcpputils
      rcutils
      TinyXML2
    )
    target_compile_definitions(${PROJECT_NAME}_utest PUBLIC "PLUGINLIB__DISABLE_BOOST_FUNCTIONS")

    if(UNIX AND NOT APPLE)
      target_link_libraries(${PROJECT_NAME}_utest ${FILESYSTEM_LIB})
    endif()
    add_dependencies(${PROJECT_NAME}_utest "${mock_install_target}")
  endif()

endif()

ament_package(
  CONFIG_EXTRAS "pluginlib-extras.cmake"
)

=== debian/changelog ===
ros-foxy-pluginlib (2.5.4-1focal) focal; urgency=high

  * Enable plugin testing (#202 <https://github.com/ros/pluginlib/issues/202>)
  * Make the default filesystem lib c++fs unless otherwise specified (#214 <https://github.com/ros/pluginlib/issues/214>)
  * Contributors: Ahmed Sobhy, Karsten Knese, Shane Loretz

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Mon, 31 Jan 2022 08:00:00 -0000

ros-foxy-pluginlib (2.5.3-1focal) focal; urgency=high

  * Add QNX C++ fs library compiler option (#205 <https://github.com/ros/pluginlib/issues/205>) (#213 <https://github.com/ros/pluginlib/issues/213>)
  * Contributors: Ahmed Sobhy

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Tue, 08 Dec 2020 08:00:00 -0000

ros-foxy-pluginlib (2.5.2-1focal) focal; urgency=high

  * Link against tinyxml2 correctly (#190 <https://github.com/ros/pluginlib/issues/190>)
  * Export tinyxml2 directly from pluginlib-extras.cmake (#192 <https://github.com/ros/pluginlib/issues/192>)
  * Contributors: Karsten Knese, Sean Yen

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Tue, 26 May 2020 07:00:00 -0000

ros-foxy-pluginlib (2.5.1-1focal) focal; urgency=high

  * Add missing export of stdc++fs and TinyXML2 via modern CMake (#189 <https://github.com/ros/pluginlib/issues/189>)
  * Contributors: Dirk Thomas

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Thu, 07 May 2020 07:00:00 -0000

ros-foxy-pluginlib (2.5.0-1focal) focal; urgency=high

  * Export CMake targets in a addition to include directories / libraries. (#188 <https://github.com/ros/pluginlib/issues/188>)
  * Use rcpputils for library names. (#186 <https://github.com/ros/pluginlib/issues/186>)
  * Fix filesystem linking on clang9. (#183 <https://github.com/ros/pluginlib/issues/183>)
  * Contributors: Alejandro Hernández Cordero, Dirk Thomas, Emerson Knapp

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Sat, 25 Apr 2020 07:00:00 -0000

ros-foxy-pluginlib (2.4.1-1focal) focal; urgency=high

  * Avoid build break for Visual Studio 2019 v16.3 (#166 <https://github.com/ros/pluginlib/issues/166>)
  * Contributors: Sean Yen, Steven! Ragnarök

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Wed, 23 Oct 2019 07:00:00 -0000

ros-foxy-pluginlib (2.4.0-1focal) focal; urgency=high

  * Export tinyxml2 libraries downstream. (#154 <https://github.com/ros/pluginlib/issues/154>)
  * Contributors: Esteve Fernandez

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Wed, 18 Sep 2019 07:00:00 -0000

ros-foxy-pluginlib (2.3.1-1focal) focal; urgency=high

  * [ros2] Cast pointers to void * when using %p (#152 <https://github.com/ros/pluginlib/issues/152>)
  * Contributors: Shane Loretz

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Wed, 08 May 2019 07:00:00 -0000

ros-foxy-pluginlib (2.3.0-1focal) focal; urgency=high

  * Updated build to choose the appropriate library for experimental filesystem, based on the compiler and standard library. (#146 <https://github.com/ros/pluginlib/issues/146>)
  * Added stdc++fs as a target link library for clang compiler on linux. (#144 <https://github.com/ros/pluginlib/issues/144>)
  * Added Michael as maintainer (for build e-mails). (#137 <https://github.com/ros/pluginlib/issues/137>)
  * Contributors: Emerson Knapp, Michael Carroll, bhatsach

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Sun, 14 Apr 2019 07:00:00 -0000

ros-foxy-pluginlib (2.2.1-1focal) focal; urgency=high

  * Removed extraneous link lines. (#135 <https://github.com/ros/pluginlib/issues/135>)
  * Collapsed testing packages back into pluginlib package. (#134 <https://github.com/ros/pluginlib/issues/134>)
  * Contributors: Michael Carroll

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Thu, 13 Dec 2018 08:00:00 -0000

ros-foxy-pluginlib (2.2.0-1focal) focal; urgency=high

  * Reorganized tests into fixture and consumer packages. (#130 <https://github.com/ros/pluginlib/issues/130>)
  * Updated maintainer (#129 <https://github.com/ros/pluginlib/issues/129>)
  * Fixed plugin description installation to relative subdirectory (#122 <https://github.com/ros/pluginlib/issues/122>)
  * Contributors: Michael Carroll, Mikael Arguedas

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Tue, 20 Nov 2018 08:00:00 -0000

ros-foxy-pluginlib (2.1.1-1focal) focal; urgency=high

  * export rcutils (#120 <https://github.com/ros/pluginlib/issues/120>)
  * Contributors: Karsten Knese

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Tue, 17 Jul 2018 07:00:00 -0000

ros-foxy-pluginlib (2.1.0-1focal) focal; urgency=high

  * Fix compile error with gcc 8.1.0 (#116 <https://github.com/ros/pluginlib/issues/116>)
  * remove extra semicolon to fix pedantic warning (#103 <https://github.com/ros/pluginlib/issues/103>)
  * use new class_loader header names (#99 <https://github.com/ros/pluginlib/issues/99>)
  * adjust library search to work on windows, warn about lib prefix (#97 <https://github.com/ros/pluginlib/issues/97>)
  * vs2015 doesnt support __has_include, VS2015 and 2017 have both <files… (#96 <https://github.com/ros/pluginlib/issues/96>)
  * move pluginlib in its own folder (port 83 to ros2 branch) (#95 <https://github.com/ros/pluginlib/issues/95>)
  * Contributors: Mikael Arguedas, William Woodall, jerry73204

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Thu, 21 Jun 2018 07:00:00 -0000

ros-foxy-pluginlib (1.11.0-1focal) focal; urgency=high

  * Switch to Tinyxml2 (#59 <https://github.com/ros/pluginlib/issues/59>)
  * do not use popen to solve catkin_path. (#49 <https://github.com/ros/pluginlib/issues/49>)
  * switch to package format 2 (#55 <https://github.com/ros/pluginlib/issues/55>)
  * remove trailing whitespaces (#54 <https://github.com/ros/pluginlib/issues/54>)
  * Contributors: Dmitry Rozhkov, Koji Terada, Mikael Arguedas

 -- Steven! Ragnarök <stevenragnarok@osrfoundation.org>  Thu, 27 Jul 2017 07:00:00 -0000

ros-foxy-pluginlib (1.10.5-1focal) focal; urgency=high



=== debian/control ===
Source: ros-foxy-pluginlib
Section: misc
Priority: optional
Maintainer: Steven! Ragnarök <stevenragnarok@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake, ros-foxy-ament-cmake-gtest, ros-foxy-ament-index-cpp, ros-foxy-class-loader, ros-foxy-rcpputils, ros-foxy-rcutils, ros-foxy-tinyxml2-vendor, ros-foxy-ros-workspace
Homepage: http://www.ros.org/wiki/pluginlib
Standards-Version: 3.9.2

Package: ros-foxy-pluginlib
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-ament-index-cpp, ros-foxy-class-loader, ros-foxy-rcpputils, ros-foxy-rcutils, ros-foxy-tinyxml2-vendor, ros-foxy-ros-workspace
Description: The pluginlib package provides tools for writing and dynamically loading plugins using the ROS build infrastructure.
 To work, these tools require plugin providers to register their plugins in the package.xml of their package.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-pluginlib//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
